%ZUTILS ; Implementations of missing functionality in FreeM
 ; Written by David Wicksell <dlw@linux.com>
 ; Fourth Watch Software LC
 ; Copyright (C) 2020
MERGE(SOURCE,DESTINATION) ; Implement the merge command
 ; SOURCE = M array to merge from passed by name indirection
 ; DESTINATION = M array to merge to passed by name indirection
 ; returns 0 on success, -1 on error
 ;
 ; SOURCE is an array descendant of DESTINATION; throw M19 (error code 158)
 IF $EXTRACT(SOURCE,1,$LENGTH(DESTINATION))=DESTINATION QUIT -1
 ; DESTINATION is an array descendant of SOURCE; throw M19 (error code 158)
 IF $EXTRACT(DESTINATION,1,$LENGTH(SOURCE))=SOURCE QUIT -1
 ;
 ; set DESTINATION clear base name
 NEW DST
 SET DST=DESTINATION
 ;
 ; set SOURCE break flag
 NEW SRC
 SET SRC=SOURCE,$QSUBSCRIPT(SRC,0)="",$EXTRACT(SRC,$LENGTH(SRC))=""
 ;
 ; set the SOURCE POP offset
 NEW POP
 IF $QLENGTH(SOURCE)>$QLENGTH(DESTINATION) SET POP=$QLENGTH(SOURCE)-$QLENGTH(DESTINATION)
 ELSE  SET POP=0
 ;
 ; set the DESTINATION PUSH offset
 NEW PUSH
 IF $QLENGTH(DESTINATION)>$QLENGTH(SOURCE) SET PUSH=$QLENGTH(DESTINATION)-$QLENGTH(SOURCE)
 ELSE  SET PUSH=0
 ;
 ; merge initial node, if it exists
 SET:$DATA(@SOURCE)#2 @DESTINATION=@SOURCE
 ;
 ; merge the rest of the nodes
 NEW I,TST
 FOR  SET SOURCE=$QUERY(@SOURCE) QUIT:(SOURCE="")!(SRC=-1)  DO
 . ; quit at the end of a SOURCE sub-tree
 . SET TST=SOURCE,$QSUBSCRIPT(TST,0)="",TST=$EXTRACT(TST,1,$LENGTH(SRC))
 . IF TST'=SRC SET SRC=-1 QUIT
 . ;
 . ; clear DESTINATION keys
 . SET DESTINATION=DST
 . ; rebuild the DESTINATION array keys
 . FOR I=1:1:($QLENGTH(SOURCE)-POP) DO
 . . SET $QSUBSCRIPT(DESTINATION,I+PUSH)=$QSUBSCRIPT(SOURCE,I+POP)
 . ;
 . ; set the next node
 . SET @DESTINATION=@SOURCE
 ;
 QUIT 0
