/*                            *
 *                           * *
 *                          *   *
 *                     ***************
 *                      * *       * *
 *                       *  MUMPS  *
 *                      * *       * *
 *                     ***************
 *                          *   *
 *                           * *
 *                            *
 *
 * Shalom ha-Ashkenaz, 1998/06/18 CE
 * 
 * module for error messages
 * 
 */

int     SIflag[MAXDEV + 1] = {1, 1, 1, 1, 1};           /* SI/SO flag */

char    errmes[MAXERR][ERRLEN] = {
    "\201",                         /* OK       */
    "interrupt\201",                /* INRPT    */
    "BREAK point\201",              /* BKERR    */
    "non standard syntax\201",      /* NOSTAND  */
    "variable not found\201",       /* UNDEF    */
    "label not found\201",          /* LBLUNDEF */
    "missing operand\201",          /* MISSOPD  */
    "missing operator\201",         /* MISSOP   */
    "unrecognized operator\201",    /* ILLOP    */
    "unmatched quotes\201",         /* QUOTER   */
    "comma expected\201",           /* COMMAER  */
    "equals '=' expected\201",      /* ASSIGNER */
    "argument not permitted\201",   /* ARGER    */
    "blank ' ' expected\201",       /* SPACER   */
    "unmatched parentheses\201",    /* BRAER    */
    "level error\201",              /* LVLERR   */
    "divide by zero\201",           /* DIVER    */
    "function not found\201",       /* ILLFUN   */
    "wrong number of function arguments\201",   /* FUNARG   */
    "ZTRAP error\201",              /* ZTERR    */
    "$NEXT/$ORDER error\201",       /* NEXTER   */
    "$SELECT error\201",            /* SELER    */
    "illegal command\201",          /* CMMND    */
    "argument list incorrect\201",  /* ARGLIST  */
    "invalid expression\201",       /* INVEXPR  */
    "invalid reference\201",        /* INVREF   */
    "string too long\201",          /* MXSTR    */
    "too many parameters\201",      /* TOOPARA  */
    "unit not open\201",            /* NOPEN    */
    "unit does not exist\201",      /* NODEVICE */
    "file protection violation\201",/* PROTECT  */
    "global not permitted\201",     /* GLOBER   */
    "file not found\201",           /* FILERR   */
    "program overflow\201",         /* PGMOV    */
    "stack overflow\201",           /* STKOV    */
    "symbol table overflow\201",    /* STORE    */
    "file won't read\201",          /* NOREAD   */
    "file won't write\201",         /* NOWRITE  */
    "routine not found\201",        /* NOPGM    */
    "illegal naked reference\201",  /* NAKED    */
    "illegal subscript\201",        /* SBSCR    */
    "insert syntax\201",            /* ISYNTX   */
    "database degradation\201",     /* DBDGD    */
    "job kill signal\201",          /* KILLER   */
    "hangup signal\201",            /* HUPER    */
    "numeric overflow\201",         /* MXNUM    */
    "function returns no value\201",/* NOVAL    */
    "type mismatch\201",            /* TYPEMISMATCH */
    "out of memory\201",            /* MEMOV */
    "error in name resolution\201", /* NAMERES */
    "error creating socket\201",    /* SCKCREAT */
    "invalid address family (must be IPV4 or IPV6)\201",    /* SCKIFAM */
    "invalid connection type (must be TCP or UDP)\201",     /* SCKITYP */
    "invalid port number\201",                              /* SCKIPRT */
    "connection error\201",                                 /* SCKCERR */
    "USE action invalid for connection type (possibly CONNECT on UDP socket?)\201", /* SCKAERR */
    "attempted to CONNECT an already-connected socket\201", /* SCKACON */
    "attempted to READ from a disconnected TCP socket\201", /* SCKNCON */
    "error setting socket options\201",                     /* SCKEOPT */
    "error in READ from socket\201",                        /* SCKERCV */
    "error in WRITE to socket\201",                         /* SCKESND */
    " \201",                         
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    "invalid value for $ECODE\201",                         /* ECODEINV */
    "programmer assertion failed\201",                      /* ASSERT */
    "user-defined error\201",                               /* USERERR */
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    "syntax error\201",
    "break\201",
    " \201",
    "asynchronous interruption\201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    "naked indicator undefined\201",                        /* M1 */                    
    "invalid combination with $FNUMBER code atom\201",      /* M2 ... */
    "$RANDOM seed less than 1\201",                         /* M3 etc. */
    "no true condition in $SELECT\201",
    "line reference less than zero\201",
    "undefined local variable\201",
    "undefined global variable\201",
    "undefined intrinsic special variable\201",
    "divide by zero\201",
    "invalid pattern match range\201",
    "no parameters passed\201",
    "invalid line reference (negative offset)\201",
    "invalid line reference (line not found)\201",
    "line level not 1\201",
    "undefined index variable\201",
    "argumented QUIT not allowed\201",
    "argumented QUIT required\201",
    "fixed length READ not greater than zero\201",
    "cannot copy a tree or subtree into itself\201",
    "line must have a formal parameter list\201",
    "algorithm specification invalid\201",
    "SET or KILL to ^$GLOBAL when data in global\201",
    "SET or KILL to ^$JOB for non-existent job number\201",
    "change to collation algorithm while subscripted local variables defined\201",
    " \201",
    "non-existent environment\201",
    "attempt to rollback a transaction that is not restartable\201",
    "mathematical function, parameter out of range\201",
    "SET or KILL on structured system variable not allowed by implementation\201",
    "reference to global variable with different collating sequence within a collating algorithm\201",
    "control mnemonic used for device without a mnemonic space selected\201",
    "control mnemonic used in user-defined mnemonic space which has no associated line\201",
    "SET or KILL to ^$ROUTINE when routine exists\201",
    " \201",
    "device does not support mnemonic space\201",
    "incompatible mnemonic spaces\201",
    "READ from device identified by the empty string\201",
    "invalid structured system variable subscript\201",
    "invalid $NAME argument\201",
    "call-by-reference in JOB actual parameter\201",
    "invalid LOCK argument within a transaction\201",
    "invalid QUIT within a transaction\201",
    "invalid range value ($X, $Y)\201",
    "invalid command outside of a transaction\201",
    "invalid GOTO reference\201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    "identifier exceeds maximum length\201",
    "more than one defining occurrence of label in routine\201",
    "too few formal parameters\201",
    " \201",
    "illegal attempt to use an undefined SSVN\201",             /* M60 */
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    " \201",
    "synchronous and asynchronous event processing cannot be simultaneously enabled for the same event class\201"
};
